#include 'InnoTools\it_callback.iss'

#include 'utils.iss'

[Code]
var
  HelpButton: TButton;
  NextButtonTimer, NextButtonWait: LongWord;

procedure CommonUI_OnHelpButtonClick(Sender: TObject);
var
  ErrorCode: Integer;
begin
  ShellExec('open', '{#SupportUrl}', '', '', SW_SHOWNORMAL, ewNoWait, ErrorCode);
end;

procedure CommonUI_Create(ParentForm: TSetupForm; CancelButton: TNewButton);
begin
  HelpButton := TButton.Create(ParentForm);
  HelpButton.Parent := ParentForm;
  HelpButton.Caption := CustomMessage('apex_help');
  HelpButton.Top := CancelButton.Top;
  HelpButton.Left := ParentForm.ClientWidth - CancelButton.Left - CancelButton.Width;
  HelpButton.Width := CancelButton.Width;
  HelpButton.Height := CancelButton.Height;
  HelpButton.OnClick := @CommonUI_OnHelpButtonClick;

  // Hide these by default
  HelpButton.Hide();
end;

procedure CommonUI_Show(bShow: Boolean);
begin
  if bShow then begin
    HelpButton.Show();
  end else begin
    HelpButton.Hide();
  end;
end;

procedure CommonUI_UnsetPageDelay();
begin
  WizardForm.NextButton.Caption := SetupMessage(msgButtonNext);
  WizardForm.NextButton.Enabled := True;

  if NextButtonTimer <> 0 then begin
    KillTimer(0, NextButtonTimer);
    NextButtonTimer := 0;
  end;
end;

procedure CommonUI_OnTimer(hWnd: HWND; uMsg: LongWord; idEvent: LongWord; dwTime: LongWord);
begin
  NextButtonWait := NextButtonWait - 1;
  WizardForm.NextButton.Caption := IntToStr(NextButtonWait);
  if Integer(NextButtonWait) < 0 then
    CommonUI_UnsetPageDelay();
end;

function CommonUI_SetPageDelay(Seconds: Integer): Boolean;
begin
  NextButtonWait := Seconds;
  WizardForm.NextButton.Enabled := False;
  WizardForm.NextButton.Caption := IntToStr(NextButtonWait);

  NextButtonTimer := SetTimer(0, 0, 1000, WrapTimerProc(@CommonUI_OnTimer, 4));
  Result := NextButtonTimer <> 0;
end;

function CommonUI_GetFinalReadyMemo(NewLine, UserInfo, DirInfo, TypeInfo, ComponentsInfo, GroupInfo, TasksInfo: String): String;
begin
  if UserInfo <> '' then
    Result := Result + UserInfo + NewLine + NewLine;

  if DirInfo <> '' then
    Result := Result + DirInfo + NewLine + NewLine;

  if TypeInfo <> '' then
    Result := Result + TypeInfo + NewLine + NewLine;

  if ComponentsInfo <> '' then
    Result := Result + ComponentsInfo + NewLine + NewLine;

  if GroupInfo <> '' then
    Result := Result + GroupInfo + NewLine + NewLine;

  if TasksInfo <> '' then
    Result := Result + TasksInfo + NewLine + NewLine;
end;